// Exame Recuperacao - TecProg - S73 - 1 Sem 2023 - Prof. Simo DAINF - UTFPR - Ctba
// Testado em codeblocks 20.03

// Questo 1

// a - vide diagrama de classes.

// b - vide uso intensivo de const

// c - Sim h polimorfismo graas ao conteuo do mtodo percorrimento em Frota, o que  possvel
// graas a virtualidade existente na classe base Veiculo, sendo que em sendo a funo virtual pertinente
// pura, j se intui de antemo que a Frota enquanto uma coleo de apontamento de Veiculo trabalhar
// certamente em um quadro de polimorfismo.

// Template, Builder e Singleton, sendo este ltimo aplicado na ltima questo.

#include <iostream>
#include <string>
#include <set>
using namespace std;

#include <string.h>

namespace Veiculos
{
    class Veiculo
    {
        protected:

            char* nome;
            float x, y;

        public:

            Veiculo(const char* _nome = "", const float _x = 0, const float _y = 0):
                nome (NULL),
                x (_x),
                y (_y)
            {
                int tam = strlen(_nome);
                nome = new char[tam];
                strcpy(nome, _nome);
            }

            virtual ~Veiculo()
            {
                if (nome)
                {
                    delete []nome;
                }
            }

            virtual void atualizar() = 0;

            void mostrar()
            {
                atualizar();
                cout << nome << " " << x << " " <<  y << endl;
            }

            const int getX() const { return x; }
            const int getY() const { return y; }
    };

    class Moto : public Veiculo
    {
        protected:
            int multas;

        public:
            Moto(const char* _nome = "", const float _x = 0, const float _y = 0, const int _multas = 0):
            Veiculo(_nome, _x, _y),
            multas(_multas)
            {
            }

            virtual ~Moto()
            {
            }

            virtual void atualizar()
            {
                x+= 2.0;
                y+= 2.0;
            }
    };

    class Viatura : public Veiculo
    {
        protected:
            bool sirene;

        public:
            Viatura(const char* _nome = "", const float _x = 0, const float _y = 0, const float _sirene = false) :
            Veiculo(_nome, _x, _y),
            sirene(_sirene)
            {
            }

            virtual ~Viatura()
            {
            }

            virtual void atualizar()
            {
                x+= 4.0;
                y+= 2.0;
            }
    };
}
using namespace Veiculos;

class Frota
{
    private:
        set<Veiculo*> conjunto;
        set<Veiculo*>::const_reverse_iterator i;

    public:
        Frota()
        {
            conjunto.clear();
        }

        ~Frota()
        {
            Veiculo* paux = NULL;

            i = conjunto.rbegin();

            while (i != conjunto.rend())
            {
                paux = *i;
                if (paux != NULL)
                {
                    delete paux;
                }

                paux = NULL;
                i++;
            }
            excluir();
        }

        void incluir(Veiculo* ponteiro)
        {
            if (ponteiro != NULL)
            {
                conjunto.insert(ponteiro);
            }
            else
            {
                cerr << "Erro - apontamento nulo" << endl;
            }
        }

        void excluir()
        {
            if (!conjunto.empty())
            {
                conjunto.clear();
            }
        }

        void percorrer()
        {
            i = conjunto.rbegin();
            while (i != conjunto.rend())
            {
                (*i)->mostrar();
                i++;
            }
        }
}; // Se classe frota for feita com outro componente, lembrar que teria
   // que programar a funcionalidade do set de no permitie elemento repetido...

class Simulador
{
    private:
        Moto*      pm1;
        Moto*      pm2;
        Viatura*    pv1;

        Frota*      pf;

        static const int MAX;

        static Simulador*  pSimulador;

    private:

    Simulador()
    : pm1(NULL), pm2(NULL), pv1(NULL), pf(NULL)
    {
        cout << "TESTE" << endl;

        pf = new Frota();

        pm1= new Moto("cidado", 2, 2, 0);
        pm2= new Moto("meliante", 1, 2, 1500);
        pv1= new Viatura("polcia", 0, 0, true);

        pf->incluir(static_cast<Veiculo*>(pm1));
        pf->incluir(static_cast<Veiculo*>(pm2));
        pf->incluir(static_cast<Veiculo*>(pv1));

        executar();
    }

    public:

    ~Simulador()
    {
        //if (pm1 != NULL) { delete pc1; pc1 = NULL;}
        //if (pm2 != NULL) { delete pc2; pc2 = NULL;}
        //if (pv1 != NULL) { delete pv1; pv1 = NULL;}

        if (pf != NULL)  { delete pf; pf = NULL; }
    }

    void executar()
    {
        int i = 0;
        do
        {
            pf->percorrer();

            if (
                 (pm2->getX() == pv1->getX()) &&
                 (pm2->getY() == pv1->getY())
               )
            {

                cout << endl << "Meliante est preso!" << endl;
                return;
            }
            i++;
        }
        while ( i < MAX );

        cout << endl << "Meliante escapou!" << endl;
        cout << endl;

    }

    static Simulador* getInstance()
    {
        if (pSimulador == NULL)
        {
            pSimulador = new Simulador();
        }

        return pSimulador;
    }

};

const int Simulador::MAX(100);

Simulador* Simulador::pSimulador(NULL);

int main()
{
    Simulador* simulador1 = NULL;

    simulador1 = Simulador::getInstance();

    if (simulador1) delete simulador1;

    return 0;
}
